using System;

namespace Vrednost_dodele
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] inp = Console.ReadLine().Split(null);
            int N = int.Parse(inp[0]);
            int M = int.Parse(inp[1]);

            uint[] B = Array.ConvertAll(Console.ReadLine().Split(null), uint.Parse);
            
            int C = int.Parse(Console.ReadLine());

            int[] A = new int[N + 1];
            for (int i = 1; i <= N; i++)
                A[i] = i;

            for (int i = 0; i <= N - M; i++)
            {
                for (int j = 1; j <= M; j++)
                    A[i + B[j-1]] = A[i + j];
            }

            long X = 0;

            for(int i = 1; i <= N; i++)
            {
                X += (long)Math.Pow(C, i) * A[i];
            }

            Console.WriteLine(X% 998244353);
        }
    }
}